package com.jz.manage.moduls.controller.goods;

import com.jz.common.entity.DataGoods;
import com.jz.common.utils.Result;
import com.jz.common.utils.StatusCode;
import com.jz.manage.moduls.controller.BaseController;
import com.jz.manage.moduls.controller.goods.bean.dto.DataGoodsApiDto;
import com.jz.manage.moduls.service.DataGoodsApiService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * api商品(TDataGoodsApi)表控制层
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:31
 */
@RestController
@RequestMapping("dataGoodsApi")
public class DataGoodsApiController extends BaseController {
    /**
     * 服务对象
     */
    @Autowired
    private DataGoodsApiService tDataGoodsApiService;

    /**
     * 根据主键查询商品详情-api
     * @param id
     * @return
     */
    @GetMapping("/getDataDetails/{id}")
    @ApiOperation(value = "点击商品查看商品详情", notes = "api商品")
    public Result<DataGoodsApiDto> findById(@PathVariable(value = "id") Long id) {
        if (id != null) {
            Result<DataGoodsApiDto> result = new Result<>();
            DataGoodsApiDto dataGoodsApi = tDataGoodsApiService.selectById(id);
            return new Result<DataGoodsApiDto>(true, "查询商品详情成功！", StatusCode.OK, dataGoodsApi);
        }
        return new Result<>(false, "查询商品详情失败！");
    }
}